#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define acc 0.000001

#define lo 1
#define hi 2.3
#define n (hix - lox + 1)

#define h 0.1
#define a 0

#define lox 0
#define hix 35

float *xk, *fx;

float
f (float x)
{
 float y, s, p;
 s = 0;
 y = 0;
 for (p = lo; p <= hi; p += acc)
   {
    y = x / (p + 1);
    s += acc * y;
   }
 return s;
}

float
Lgn (float x)
{
 float multS, sumS;
 sumS = 0;
 for (int k = 0; k < n; k++)
   {
    multS = 1;
    for (int i = 0; i < n; i++)
        if (i != k)
	 multS *= ((x - xk[i]) / (xk[k] - xk[i]));
    multS *= fx[k];
    sumS += multS;
   }
 return sumS;
}

int
main ()
{
 fx = (float *) malloc (n * sizeof (float));
 xk = (float *) malloc (n * sizeof (float));

 for (int k = 0; k < n; k++)
   {
    xk[k] = a + k * h;
    fx[k] = f (xk[k]);
   }

 printf("%f\n", f(3.1) - Lgn(3.1));
 free (fx);
 free (xk);
 return 0;
}
